/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*-

this file is part of rcssserver3D
Fri May 9 2003
Copyright (C) 2002,2003 Koblenz University
Copyright (C) 2003 RoboCup Soccer Server 3D Maintenance Group

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef AGENT3D_COMMSERVER_H
#define AGENT3D_COMMSERVER_H

#include <string>
#include <zeitgeist/class.h>
#include <zeitgeist/leaf.h>
#include "ReadBuffFD.h"

class CommServer
    : public zeitgeist::Leaf {
public:
    CommServer();
    virtual
    ~CommServer();

    bool getInput();
    void putOutput( const char* out );
    void putOutput( const std::string& str )
      {
          putOutput( str.c_str() );
      }

    const
    char* getMsg() const
      {
          return M_buffer;
      }

protected:
    bool selectInput();

protected:
    // the input file descriptor
    const int M_read_fd;

    // the output file descriptor
    const int M_write_fd;

    // the receive buffer
    static const unsigned int DEFAULT_BUFFER_SIZE = 8192;
    char* M_buffer;
    unsigned int M_buffer_size;

private:
    spades::ReadBuffFD M_read_buf_fd;
};

DECLARE_CLASS(CommServer);

#endif // COMMSERVER_H
